#if !defined(particle_h)
#define      particle_h

#include "main.h"
#include "utility.h"

//---------------------------------------------------------------------------------
 
class Particle{
public:		Particle();
	virtual ~Particle();

	struct aparticle{
		float x,y,z,xi,yi,zi, lastx,lasty,lastz, size;
		float pitch, heading, roll, pitchi, headingi, rolli, slickness,
			mass, r0,g0,b0,r1,g1,b1, lifeTime, birthTime, deathTime;
		int on;
	} p[101];

	Texture *tex;
	int maxparticles, alphatest, blend, depthtest, depthwrite;
	int blendFunc0,blendFunc1, init, bouncey, canroll;
	float x,y,z, xi,yi,zi, windx,windy,windz, size0,size1, sizeRnd, alphafunc;
	float tx0, tx1, ty0, ty1;
	float dispersex, dispersey, dispersez, drag, mass, length;
	float pitch,pitchi, heading,headingi, roll,rolli, rollspeed;
	float lifeTime, lastTime, interval;
	float inten0, inten1, r0,g0,b0, r1, g1, b1, alpha0, alpha1, colorRnd, lifeTimeRnd;

	static Time *time;
	static Pref *pref;
	static Camera *camera;

	int  create(float x, float y, float z);
	void update(void);
	void draw(void);
	void kill(void);
	int  collision(float x, float y, float z, float distance);
	int  count(void);
	void set(void);
	void unset(void);
};

//---------------------------------------------------------------------------------------

#endif