#if !defined(texture_h)
#define      texture_h

#include "main.h"
#include "utility.h"

//---------------------------------------------------------------------------------

enum  bob {SPHERE, NOTSPHERE, GRADIENT, HALO, FIREHALO,
           STAR, SMOKE, STARFIELD, CHECK, GRID, SAND, PERLIN, SPARK, CROSS};

class Texture{
public:     Texture();
	virtual ~Texture();

	static GLuint lastTexID;
	GLuint texID;
	int repeatMode,  blendMode;

	void bind(void);

	int loadtex(const char *picname, int alpha, int threshold, int mipmap);
	int loadtexInt(const char *picname, int alpha, int threshold, int mipmap);
	void maketextype(int type, int mipmap, float f=.25, int i=6);
	void maketextypeint(int type, int mipmap, float f=.25, int i=6);
	void maketextype2(int type, int mipmap, float f=.25, int i=6);
	void mip(int mipmap);
};


void sunflare(GLuint tex_sun);
void noisy1(GLuint texID, int grain, int size, int lightmap);

//---------------------------------------------------------------------------------

#endif