#if !defined(utility_h)
#define      utility_h

#include <iostream.h>
#include <fstream.h>
#include "counter.h"
#include "object.h"
#include "text.h"
class Text;

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
class Pref;


// this file protos ---------------------------------------------------------------
void   normalize(float *x, float *y, float *z);
//void   rot_point(double pt1,double hd1,double yw1,double *xf,double *yf,double *zf);
void rot_point(float pt1,float hd1,float yw1,float *xf,float *yf,float *zf);
double rndn(double range);	  // rnd # (0->.99999 * range)
float  cos_interp(float a, float b, float x);
float  lin_interp(float a, float b, float x);
void   solid_sphere(double size, int nx, int ny,
						  double texmagx, double texmagy, 
						  double texoffx, double texoffy);
void solid_torus(int tes, double size, double thick);

void delay(int milliseconds);
int  get_time(void);
//void showmatrix(float, float, float *);
void showmatrix(float *m, float iny, Text *text);

void show_rot(float, float);
void partial_sphere(float size, int tesx, int tesy,
					float toffx, float toffy,
					float startx, float starty,	float endx, float endy);
void set_blend(int blend0, int blend1);
void doc_blend(int type, int n, Text *text);
void limitv(float *x, float *y, float *z, float limit);
void set_polymode(Pref *pref);
float minv(float value0, float value1);
float maxv(float value0, float value1);
float clamp_high(float value, float limit);
float clamp_low(float value, float limit);
void shadowMatrix(float ground[4], float light[4]);

float wrapMax(float value, float compare);
float wrapMin(float value, float compare);
int wrapMax(int value, int compare);
int wrapMin(int value, int compare);
void logo321(float t, Texture *tex, Text *gen);
void end_shatter(float init, Texture *tex, Screen *screen, Time *time, Pref *pref,
				 int *capture, float *skip);
void draw_cube(float w0,float h0,float d0);
void set_fog(int universe);
void set_fogcolor(float r, float g, float b, float a);
void draw_pill(float size, float thick);
int log_message(char *s);

//---------------------------------------------------------------------------------------

#endif